# coding: utf-8

"""
    Marketplace API

    An API for the AI Maintainer Marketplace

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field

class Agent(BaseModel):
    """
    Agent
    """
    agent_id: Optional[Any] = Field(..., alias="agentId", description="The Id of the agent.")
    agent_name: Optional[Any] = Field(..., alias="agentName", description="The unique name of the agent.")
    user_id: Optional[Any] = Field(..., alias="userId", description="The Id of the user associated with the agent.")
    user_name: Optional[Any] = Field(..., alias="userName", description="The unique name of the user associated with the agent.")
    webhook_url: Optional[Any] = Field(..., alias="webhookUrl", description="The webhook URL of the agent.")
    webhook_secret: Optional[Any] = Field(..., alias="webhookSecret", description="The webhook secret of the agent.")
    created_at: Optional[Any] = Field(..., alias="createdAt", description="The date and time the agent was created.")
    updated_at: Optional[Any] = Field(..., alias="updatedAt", description="The date and time the agent was last updated.")
    __properties = ["agentId", "agentName", "userId", "userName", "webhookUrl", "webhookSecret", "createdAt", "updatedAt"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Agent:
        """Create an instance of Agent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if agent_id (nullable) is None
        # and __fields_set__ contains the field
        if self.agent_id is None and "agent_id" in self.__fields_set__:
            _dict['agentId'] = None

        # set to None if agent_name (nullable) is None
        # and __fields_set__ contains the field
        if self.agent_name is None and "agent_name" in self.__fields_set__:
            _dict['agentName'] = None

        # set to None if user_id (nullable) is None
        # and __fields_set__ contains the field
        if self.user_id is None and "user_id" in self.__fields_set__:
            _dict['userId'] = None

        # set to None if user_name (nullable) is None
        # and __fields_set__ contains the field
        if self.user_name is None and "user_name" in self.__fields_set__:
            _dict['userName'] = None

        # set to None if webhook_url (nullable) is None
        # and __fields_set__ contains the field
        if self.webhook_url is None and "webhook_url" in self.__fields_set__:
            _dict['webhookUrl'] = None

        # set to None if webhook_secret (nullable) is None
        # and __fields_set__ contains the field
        if self.webhook_secret is None and "webhook_secret" in self.__fields_set__:
            _dict['webhookSecret'] = None

        # set to None if created_at (nullable) is None
        # and __fields_set__ contains the field
        if self.created_at is None and "created_at" in self.__fields_set__:
            _dict['createdAt'] = None

        # set to None if updated_at (nullable) is None
        # and __fields_set__ contains the field
        if self.updated_at is None and "updated_at" in self.__fields_set__:
            _dict['updatedAt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Agent:
        """Create an instance of Agent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Agent.parse_obj(obj)

        _obj = Agent.parse_obj({
            "agent_id": obj.get("agentId"),
            "agent_name": obj.get("agentName"),
            "user_id": obj.get("userId"),
            "user_name": obj.get("userName"),
            "webhook_url": obj.get("webhookUrl"),
            "webhook_secret": obj.get("webhookSecret"),
            "created_at": obj.get("createdAt"),
            "updated_at": obj.get("updatedAt")
        })
        return _obj


