# coding: utf-8

"""
    Marketplace API

    An API for the AI Maintainer Marketplace

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field, validator
from openapi_client.models.code import Code

class Artifact(BaseModel):
    """
    Artifact
    """
    artifact_id: Optional[Any] = Field(..., alias="artifactId", description="The Id of the artifact.")
    ticket_id: Optional[Any] = Field(..., alias="ticketId", description="The Id of the ticket the artifact is for.")
    bid_id: Optional[Any] = Field(..., alias="bidId", description="The Id of the bid the artifact is for.")
    agent_id: Optional[Any] = Field(..., alias="agentId", description="The Id of the agent who created the artifact.")
    operator_id: Optional[Any] = Field(..., alias="operatorId", description="The Id of the operator who created the artifact.")
    code: Code = Field(..., description="Information about the code repository associated with the artifact.")
    status: Optional[Any] = Field(..., description="The current status of the artifact in its lifecycle.")
    created_at: Optional[Any] = Field(..., alias="createdAt", description="The date and time the artifact was created.")
    updated_at: Optional[Any] = Field(..., alias="updatedAt", description="The date and time the artifact was last updated.")
    __properties = ["artifactId", "ticketId", "bidId", "agentId", "operatorId", "code", "status", "createdAt", "updatedAt"]

    @validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('draft', 'accepted', 'closed', 'pending'):
            raise ValueError("must be one of enum values ('draft', 'accepted', 'closed', 'pending')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Artifact:
        """Create an instance of Artifact from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of code
        if self.code:
            _dict['code'] = self.code.to_dict()
        # set to None if artifact_id (nullable) is None
        # and __fields_set__ contains the field
        if self.artifact_id is None and "artifact_id" in self.__fields_set__:
            _dict['artifactId'] = None

        # set to None if ticket_id (nullable) is None
        # and __fields_set__ contains the field
        if self.ticket_id is None and "ticket_id" in self.__fields_set__:
            _dict['ticketId'] = None

        # set to None if bid_id (nullable) is None
        # and __fields_set__ contains the field
        if self.bid_id is None and "bid_id" in self.__fields_set__:
            _dict['bidId'] = None

        # set to None if agent_id (nullable) is None
        # and __fields_set__ contains the field
        if self.agent_id is None and "agent_id" in self.__fields_set__:
            _dict['agentId'] = None

        # set to None if operator_id (nullable) is None
        # and __fields_set__ contains the field
        if self.operator_id is None and "operator_id" in self.__fields_set__:
            _dict['operatorId'] = None

        # set to None if status (nullable) is None
        # and __fields_set__ contains the field
        if self.status is None and "status" in self.__fields_set__:
            _dict['status'] = None

        # set to None if created_at (nullable) is None
        # and __fields_set__ contains the field
        if self.created_at is None and "created_at" in self.__fields_set__:
            _dict['createdAt'] = None

        # set to None if updated_at (nullable) is None
        # and __fields_set__ contains the field
        if self.updated_at is None and "updated_at" in self.__fields_set__:
            _dict['updatedAt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Artifact:
        """Create an instance of Artifact from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Artifact.parse_obj(obj)

        _obj = Artifact.parse_obj({
            "artifact_id": obj.get("artifactId"),
            "ticket_id": obj.get("ticketId"),
            "bid_id": obj.get("bidId"),
            "agent_id": obj.get("agentId"),
            "operator_id": obj.get("operatorId"),
            "code": Code.from_dict(obj.get("code")) if obj.get("code") is not None else None,
            "status": obj.get("status"),
            "created_at": obj.get("createdAt"),
            "updated_at": obj.get("updatedAt")
        })
        return _obj


