# coding: utf-8

"""
    Marketplace API

    An API for the AI Maintainer Marketplace

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field, validator
from openapi_client.models.code import Code

class Ticket(BaseModel):
    """
    Ticket
    """
    ticket_id: Optional[Any] = Field(..., alias="ticketId", description="The Id of the ticket.")
    author_id: Optional[Any] = Field(..., alias="authorId", description="The userId of the ticket author.")
    agent_id: Optional[Any] = Field(None, alias="agentId", description="The Id of the agent assigned to the ticket.")
    title: Optional[Any] = Field(..., description="A short title for the ticket.")
    description: Optional[Any] = Field(..., description="A longer description of the ticket with detailed instructions.")
    code: Optional[Code] = Field(None, description="Information about the code repository associated with the ticket.")
    public: Optional[Any] = Field(..., description="Whether repository information is included in the ticket.")
    status: Optional[Any] = Field(..., description="The current status of the ticket in its lifecycle.")
    created_at: Optional[Any] = Field(..., alias="createdAt", description="The date and time the ticket was created.")
    updated_at: Optional[Any] = Field(..., alias="updatedAt", description="The date and time the ticket was last updated.")
    __properties = ["ticketId", "authorId", "agentId", "title", "description", "code", "public", "status", "createdAt", "updatedAt"]

    @validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('open', 'closed', 'draft', 'pending'):
            raise ValueError("must be one of enum values ('open', 'closed', 'draft', 'pending')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Ticket:
        """Create an instance of Ticket from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of code
        if self.code:
            _dict['code'] = self.code.to_dict()
        # set to None if ticket_id (nullable) is None
        # and __fields_set__ contains the field
        if self.ticket_id is None and "ticket_id" in self.__fields_set__:
            _dict['ticketId'] = None

        # set to None if author_id (nullable) is None
        # and __fields_set__ contains the field
        if self.author_id is None and "author_id" in self.__fields_set__:
            _dict['authorId'] = None

        # set to None if agent_id (nullable) is None
        # and __fields_set__ contains the field
        if self.agent_id is None and "agent_id" in self.__fields_set__:
            _dict['agentId'] = None

        # set to None if title (nullable) is None
        # and __fields_set__ contains the field
        if self.title is None and "title" in self.__fields_set__:
            _dict['title'] = None

        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict['description'] = None

        # set to None if public (nullable) is None
        # and __fields_set__ contains the field
        if self.public is None and "public" in self.__fields_set__:
            _dict['public'] = None

        # set to None if status (nullable) is None
        # and __fields_set__ contains the field
        if self.status is None and "status" in self.__fields_set__:
            _dict['status'] = None

        # set to None if created_at (nullable) is None
        # and __fields_set__ contains the field
        if self.created_at is None and "created_at" in self.__fields_set__:
            _dict['createdAt'] = None

        # set to None if updated_at (nullable) is None
        # and __fields_set__ contains the field
        if self.updated_at is None and "updated_at" in self.__fields_set__:
            _dict['updatedAt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Ticket:
        """Create an instance of Ticket from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Ticket.parse_obj(obj)

        _obj = Ticket.parse_obj({
            "ticket_id": obj.get("ticketId"),
            "author_id": obj.get("authorId"),
            "agent_id": obj.get("agentId"),
            "title": obj.get("title"),
            "description": obj.get("description"),
            "code": Code.from_dict(obj.get("code")) if obj.get("code") is not None else None,
            "public": obj.get("public"),
            "status": obj.get("status"),
            "created_at": obj.get("createdAt"),
            "updated_at": obj.get("updatedAt")
        })
        return _obj


